#ifndef __DISTOPTIM_H
#define __DISTOPTIM_H
#include "fis.h"
#include "algo.h"

class DistOptim:public algo
{
private:
  FIS * FisFPOpt;//!< To compute attribute distance according to a fuzzy partition
  int NumFpOpt,Nbex,Ninputs,Norm;
  double Mink;
  double ** NormData;
  double* Numc;
  bool Display;

public:
 DistOptim(FIS *fis,int numinput, double* numc,double ** normdata,int nbex,int nbinpdata,bool norm,double mink,bool display): algo ( 1, 1 , 20 )//pname , pSize , NbPar
    {
      // Store "this" in the conteneur to use it later when wrapping the evaluation function.
	fEvalArgs->add(this);
	//create FP  ptr with fuzzy input argument
	FisFPOpt=fis;
	NumFpOpt=numinput;
	// create ptr on normed data
	NormData=normdata;
	Nbex=nbex;
	Ninputs=nbinpdata;
	Norm=norm;
	Mink=mink;
	Numc=numc;
	Display=display;
    }
  ~DistOptim()
    {
      //delete fuzzy input(s)
    }
  FIS * GetFisFPOpt(void){return FisFPOpt;}
  void AddfEvalArgs(int &nmf, int * &typemf,int &size, double *&params, bool &display, double &constnear);
  FISIN * GetFuzzyInputParams(int &nmf,int *& typemf, int &sizeparams, double *& paramsFP, bool display=false);

  // return 0 if updated else 1.
  int UpdateFuzzyInputFromParams(int nmf,int *typemf, int sizeparams, double * params, bool display=false, double cnear=0.);
  double PamCluster(bool display=false);
  int  launchEntry(double &gain, bool wordless);
  double optPam(void *Item, vkey * mykey,double *Array,int sizeArray);
  void setNumFpOpt(int numinput,bool display);
};// End of DistOptim class

//! Wrap a class member evaluation function in a global function
//! Global function-  Get a pointer to DistOptim instance in conteneur and call optPam 
double GlobalOptPam(void *, vkey *, double *,int,conteneur *);
//!calls R script pam.R and writes silh file with silhouette index
double PamCluster(bool display=false);
int ReadInputsOpt(const char * stri, int nbmax,double *numinputs, bool wordless);
#endif
//*********************      End of FISTOPTIM.H      ***********************


