//*********************************************************************
//
//
//                              TESTFIS.CPP
//
//
// Author(s) : Serge GUILLAUME, Brigitte CHARNOMORDIC 
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
// Object : Test FIS basic functions
// Environnement : Uses library fispro
//
//*********************************************************************

#include "fis.h"

//! This program needs 1 argument:  
//! the data file name. 
int main(int argc, char ** argv)
  //******************************
{
  if(argc < 2)
    {
      printf("\nThe program %s reads a text data file", argv[0]);
      printf("\nThe fields must be separated with an alphanumeric delimiter");
      printf("\nSpaces are not a valid delimiter");
      printf("\nIt needs 1 argument : ");
      printf("\n\t* the data file name.\n") ;
      return 1;
    }

  double ** Exemples  = NULL;  
  int nbrow=0,nbcol=0;
  int i, j;

  try{
 
    Exemples = ReadSampleFile(argv[1], nbcol,nbrow );

    printf("\nNcol : %d  NRow : %d  NbVar : %d", nbcol, nbrow, NbVarG);
    for(i = 0; i < NbVarG; i++)
      printf("\nName : %s", VarNameG[i]);
    printf("\n");
    // delete data array
    if (Exemples !=NULL) {
      for( int i=0 ; i<nbrow ; i++ )
	delete [] Exemples[i];
      delete [] Exemples;

      if(VarNameG != NULL) 
	{
	  for(j = 0; j < NbVarG; j++)
	    if(VarNameG[j] != NULL)  delete [] VarNameG[j];
	  delete [] VarNameG;
	  VarNameG = NULL;
	}
    }
   return(0);
  }
  catch(std::runtime_error &e){
    printf("catch %s\n",e.what());
    return(-1);
  }
}

//**************************   End of TESTFIS.CPP   *************************
