#include "fis.h"
#include "fpa.h"
#include "genfis.h"
#include "fistree.h"
#include "linkfis.h"
#include "hfpfis.h"
#include "fisimple.h"
#include "fisols.h"
#include "sethfpfis.h"
#include "sifopt.h"
#include "fiswm.h"
#include "hfpfis.h"
#include "gensample.h"
#include <errno.h>
#include <stdexcept>

int main(int argc, char ** argv)
  //******************************
{
  // Java_fis_jnifis_InitClasses 
  FIS *fis =NULL;
  double **data = NULL;
  int output_number=0;
  int nbcol, nbex,rep,i;
  FISIN* entree=NULL;
  MF *sef =NULL;
  FISHFP *hfp = NULL;
  char * data_file = NULL;

  fis=new FIS(argv[1]);
  data = ReadSampleFile(argv[2], nbcol, nbex);
  if( nbcol >= (fis->GetNbIn() + 1 + output_number) )
    // Observed output is part of the sample file{
    {
      rep=fis->ClassifCheck(data, nbex, 0);
    }
  cout <<"\ntest Java_fis_jnifis_InitClasses";
 
  //Java_fis_jnifis_InitPossibles
 
  for(i = 0; i < fis ->GetNbOut(); i++) fis ->Out[i]->InitPossibles(fis->Rule, fis ->GetNbRule(),i);
  
  cout <<"\ntest Java_fis_jnifis_InitPossibles";
  
  //Java_fis_jnifis_AgregationResult
  // infer first with first row
  fis->InferCheck(data[0]);
  
  cout <<"\ntest Java_fis_jnifis_AgregationResult";
  i = fis->Out[output_number] -> GetNbPossibles();
  const double * val = fis->Out[output_number] -> GetPossibles();
  double ret = 0.;  // le total pour normaliser
  for( int j=0 ; j<i ; j++ )
    ret += fis->Out[output_number] -> MuInfer[j];
  
  double *joutput_values=NULL;
  if (i !=0) 
    {
      joutput_values=new double[i];
      for( int j=0 ; j<i ; j++ )
	joutput_values[j]=val[j];
      double *weight = new double[i];
      for( int j=0 ; j<i ; j++ )
	weight[j] = fis->Out[output_number]->MuInfer[j];
      delete [] weight;
    }
  delete [] joutput_values;
  
  //Java_fis_jnifis_DataFileInfer
  cout <<"\nJava_fis_jnifis_DataFileInfer";
  double perf;
  double coveradge=0, max_err=0;
  bool display=false;
  char *result ="output";
  double blank_thres=0.2;
 


  rep = fis -> CheckConsistency();
  perf = fis->Performance( output_number, argv[2], coveradge, max_err, blank_thres, result, display );

  double temp[3];
  temp[0] = perf;
  temp[1] = coveradge;
  temp[2] = max_err;

  // Java_fis_jnifis_SortiesObtenues
  cout <<"\nJava_fis_jnifis_SortiesObtenues";
  double *jsorties = NULL;
  jsorties = new double[fis->GetNbOut()];
  fis->InferCheck(data[0]);
  for( int i=0 ; i<fis->GetNbOut() ; i++ )
    jsorties[i] = fis->OutValue[i];
  delete [] jsorties;

  //Java_fis_jnifis_InputAppartenance 
  cout <<"\nJava_fis_jnifis_InputAppartenance";
  entree = fis->In[0];
  double *jappart = NULL;
  jappart = new double[entree->GetNbMf()];
  for( int i=0 ; i<entree->GetNbMf() ; i++ )
    jappart[i] = entree->Mfdeg()[i];
  delete [] jappart;

  // Java_fis_jnifis_GetBreakPoints 
  cout<<"\nJava_fis_jnifis_GetBreakPoints ";
  int  NbBp;
  double* Bp=NULL;
  entree = fis->In[1];
  entree->GetBreakPoints(Bp, NbBp);
  double *temp1 = new double[NbBp];
  for (int i=0 ; i<NbBp ; i++)
    temp1[i] = Bp[i] ;
  delete [] Bp;
  delete [] temp1;

  //Java_fis_jnifis_IsSfp
  cout <<"\nJava_fis_jnifis_IsSfp";
  entree =fis->In[1];
  cout<<"\nJava_fis_jnifis_IsSfp";
  int *sorted = NULL;
  bool resb;
  resb=entree->IsSfp(sorted);

  //Java_fis_jnifis_IsQsp
  cout <<"\nJava_fis_jnifis_IsQsp";
  OUT_FUZZY* sortie = (OUT_FUZZY*)(fis->Out[0]);
  resb=sortie->IsQsp();

  //Java_fis_jnifis_MFSupport
  cout<<"\nJava_fis_jnifis_MFSupport";
  sef = (MF *)(fis->In[0]->GetMF(0));
  double jvalues[2];
  sef->Support( jvalues[0], jvalues[1] );
  
  //Java_fis_jnifis_MFAlphaKernel
  cout<<"\nJava_fis_jnifis_MFAlphaKernel";
  sef = (MF *)(fis->In[0]->GetMF(1));
  double jvalues1[2];
  double alpha=0.4;
  sef->AlphaKernel( jvalues1[0], jvalues1[1], alpha );
  
  //Java_fis_jnifis_RulePoids -requires inference
  cout<<"\nJava_fis_jnifis_RulePoids";
  double w;
  fis->InferCheck(data[0]);
  RULE *regle = fis->Rule[0];
  w=regle->Weight;

  //Java_fis_jnifis_DataFile
  /*
    cout<<"\nJava_fis_jnifis_DataFile";
    const char *name =argv[2];
    int colonnes, lignes;
    double ** data1 = NULL;
    double * da=NULL;
    data1 = ReadSampleFile((char *)name, colonnes, lignes );
  
    for( int i=0 ; i<lignes ; i++ )
    {
    da=new double[colonnes];
    da=data1[i];
    delete [] da;
    }
    if (data1 != NULL){
    //for(int i = 0; i < nbex; i ++) delete [] data1[i];
    delete [] data1;
    }
  */
  
  // Java_fis_jnifis_HFPHierarchyType - rien  faire

  //Java_fis_jnifis_HFPConfig 
  cout<<"\nJava_fis_jnifis_HFPConfig";
  
  data_file =argv[2];
  int ns=1;
  hfp = new FISHFP(data_file, ns, "toto.hfp");
  delete hfp;
  
  // Java_fis_jnifis_HFPVertex
  cout <<"\nJava_fis_jnifis_HFPVertex";
  data_file=argv[2];
  char *hfp_file ="toto.hfp";
  char *vertex_file = "toto.vertex";
  hfp = new FISHFP(data_file, hfp_file);
  hfp->Hierarchy(vertex_file);
  delete hfp;

  //Java_fis_jnifis_SetHFPFIS
  cout <<"\nJava_fis_jnifis_SetHFPFIS";
  char *hfpin ="toto.hfp";
  char *conf="2 2 2 2";
  char *hfpout="toto2.hfp";
  SetHfpFis(hfpin, conf, hfpout);
  
  /*//Java_fis_jnifis_HFPSelect -OK tourne 1 minute avec valgrind
    cout<<"\nJava_fis_jnifis_HFPSelect";
    hfp = NULL;
    data_file = argv[2];
    char *result_file ="resu.hfp";
    char *validation_file =argv[2];
    bool ruleInductionMethodFPA=true;
    double min_cumul_weight=0.0,loss_coverage=0.0;
    int cardinality_strategy=1;
    double min_matching_degree=0.3;
    int min_cardinality=3,initial_number_of_mf=1,max_number_of_iter=10;

    for (int i=1;i<3;i++)
    {
    hfp = new FISHFP(hfp_file, data_file, (char *)NULL);

    if( ruleInductionMethodFPA )
    hfp->SetRuleInductionMethodFpa();
    else
    hfp->SetRuleInductionMethodWm();
    hfp->SetCumWeThres(min_cumul_weight);
    hfp->SetCardStrategy(cardinality_strategy);
    hfp->SetMuMin(min_matching_degree);
    hfp->SetMinCard(min_cardinality);
    hfp->SetConfigFile(result_file);
    hfp->SetBlankThres(loss_coverage);
    hfp->SetNmfInit(initial_number_of_mf);
    hfp->SetIterMax(max_number_of_iter);
    hfp->SetVertexFile(vertex_file);
    hfp->SetNSort(output_number);
    hfp->SetValidationFile(validation_file);
    hfp->SelectFis();
    delete hfp;
    ruleInductionMethodFPA=false;
    }
  */		
  //Java_fis_jnifis_Fuz2Crisp
  cout <<"\nJava_fis_jnifis_Fuz2Crisp";
  fis->Fuz2Crisp(output_number);

  
  // Java_fis_jnifis_Crisp2Fuz
  cout<<"\nJava_fis_jnifis_Crisp2Fuz";
  fis->Crisp2Fuz(output_number, (char *)OUT_FUZZY::AreaDefuz()); 
  
  //Java_fis_jnifis_Conj2Imp
  cout <<"\nJava_fis_jnifis_Conj2Imp";
  fis->Conj2Imp(output_number, NULL,true);
  fis->Conj2Imp(output_number, NULL,false);
  
  //Java_fis_jnifis_Imp2Conj
  cout <<"\nJava_fis_jnifis_Imp2Conj";
  fis->Imp2Conj(output_number, NULL, NULL,true);
  fis->Imp2Conj(output_number, NULL, NULL,false);

  //Java_fis_jnifis_WangMendel
  cout <<"\nJava_fis_jnifis_WangMendel";
  char *fisfile =argv[1];
  data_file=argv[2];
  char *fisout="toto.wm";
  FISWM *S = NULL;
  FIS *new_fis = NULL;
  S = new FISWM(fisfile, data_file, fisout);
  S->wm();
  new_fis = new FIS(fisout);
  delete S;
  delete new_fis;

  /*
  //OK mais long - fichiers temporaires ?
  //Java_fis_jnifis_HFPSR
  cout <<"\nJava_fis_jnifis_HFPSR";
  data_file=argv[2];
  char *inputs_mfs  = "2 2 2 2";
  char *output_defuz ="area";
  char *output_disj ="sum";
  char *conjunction = "min";
  new_fis = NULL;
  FISHFP *S1 = NULL;
  char *ch2 = NULL;
  char *ch1 = NULL;
  char *ch3 = NULL;
  char *temp_fis = NULL;
  int input_hierarchy=1;
  double input_tol=0.01,output_tol=0.01;
  bool classif=false;
  int joutput_mfs=3;
  int joutput_hierarchy=1;
  
  double t = input_tol;
  if( t < 0. ) t = 0.01;

  //ch1 = tmpnam(NULL);
  ch1 ="temp.hfp";
  S1 = new FISHFP( data_file, 1, ch1, input_hierarchy );
  S1->SetToleranceThres(t);
  S1->SetConjunction(conjunction);
  S1->PrintCfgHfp( data_file, ch1 );
  delete S1; S1 = NULL;

  //ch3 = tmpnam(NULL);
  ch3="temp3.hfp";
  SetHfpFis( ch1, inputs_mfs, ch3 );

  // hfpvertex
  S1 = new FISHFP( data_file, ch3 );
  //ch2 = tmpnam(NULL);
  ch2="temp2.hfp";
  S1->Hierarchy(ch2);
  delete S1; S1 = NULL;

  t = output_tol;
  if( t < 0. ) t = 0.01;

  //temp_fis = tmpnam(NULL);
  temp_fis = "temp.fis";
  S1 = new FISHFP( ch3, data_file, temp_fis );
  S1->SetVertexFile(ch2);
  S1->GenereCfgFisSr( joutput_mfs, joutput_hierarchy, output_defuz, output_disj, t, classif );
  delete S1; S1 = NULL;

  // open FIS
  new_fis = new FIS(temp_fis);
  delete new_fis;
  /*delete [] ch2;
  delete [] ch1;
  delete [] ch3;
  delete [] temp_fis;
  */
  

  //Java_fis_jnifis_GenerateSample
  cout <<"\nJava_fis_jnifis_GenerateSample";
  int sampleNumber=2;
  double validationDataRatio=0.5;
  int seed=1;
  bool classif=true;
  int columnNumber=4;
  double precision=1e-6;
  bool truncate=true;
  data_file =argv[2];
  bool replace=false;
  for (int i=1;i<3;i++)
    {
      // 2 cases : generate n pairs of validation-test samples if replace=F
      //           generate n subsamples if replace=T
      if (replace)
	genNSamples(seed, validationDataRatio, classif, precision, columnNumber, data_file, sampleNumber, 0);
      else
	genSplit(seed, truncate, classif, precision, columnNumber, data_file, sampleNumber, 0);
      replace=true;
    }

  //Java_fis_jnifis_WriteTemplate
  cout <<"\nJava_fis_jnifis_ReadTemplate";
  jvalues[0]=0.1;
  jvalues[1]=0.2;
  char * file_name="gab1.tpl";
  WriteTemplate (file_name, jvalues[0], jvalues[1]);
  //Java_fis_jnifis_ReadTemplate
  cout <<"\nJava_fis_jnifis_ReadTemplate";
  jvalues[0]=0.1;
  jvalues[1]=0.2;
  file_name="gab1.tpl";
  ReadTemplate (file_name, jvalues[0], jvalues[1]);
  
  //Java_fis_jnifis_Infer
  cout <<"\nJava_fis_jnifis_Infer";
  double *values1 = NULL;
  values1 = new double[fis->GetNbIn()];
  for (int i=0;i<fis->GetNbIn();i++)
    values1[i]=0.0;
  fis->InferCheck( values1);
  delete [] values1;

  //Java_fis_jnifis_InferFuzzyInput
  MFDPOSS ** fuzval=NULL;
  int aff = 0;  // No display by default
  FILE *f = NULL;
  output_number = 0;
  double *sw_val = NULL;
  double *values2 = NULL;
  double *kw_val = NULL;
  int nbAlphaCut=5;
  // 0 - lecture des valeurs des sw et kw et values
  kw_val = new double[fis->GetNbIn()];
  sw_val = new double[fis->GetNbIn()];
  values2 = new double[fis->GetNbIn()];
  for( int i=0 ; i < fis->GetNbIn() ; i++ )
    {
      kw_val[i] = 0.0;
      sw_val[i] = 0.2;
      values2[i] = 0.0;
    }
  // 1 -BuildFuzIn
  fis->BuildFuzIn(values2, kw_val, sw_val, fuzval);

  if(!strcmp(fis->Out[output_number]->Defuzzify(), OUT_FUZZY::ImpFuzzyDefuz()))
    {
      fis->InferFatiPrep(output_number);
      fis->InferFatiCheck(fuzval, output_number, nbAlphaCut);
    }
  else // conjonctif
    fis->InferCheck((MF**)fuzval);
		
  delete [] values2;
  delete [] kw_val;
  delete [] sw_val;
  if (fuzval !=NULL)
    for(int i = 0; i < fis->GetNbIn(); i++)
      delete fuzval[i];
  delete [] fuzval;
		
  //Java_fis_jnifis_NewRule
  cout <<"\nJava_fis_jnifis_NewRule";
  FIS *sif =fis;
  regle = NULL;
  int *facteurs = NULL;
  double *actions = NULL;
  bool active=true;
	
  regle = new RULE();
  // lecture des facteurs
  facteurs = new int[sif->GetNbIn()];
	
	
  for( int i=0 ; i<sif->GetNbIn() ; i++ )
    facteurs[i] = 1;
		
  // lecture des actions
  actions = new double[sif->GetNbOut()];
		
  for( int i=0 ; i<sif->GetNbOut() ; i++ )
    actions[i] = 1;
  // Init de l'objet regle
  regle->SetPremise( sif->GetNbIn(), sif->In, sif->TypeConj() );
  regle->SetConclusion( sif->GetNbOut(), sif->Out );
  regle->SetAProps( facteurs );
  regle->SetConcs( actions );
  if( active == true )
    regle->Activate();
  else
    regle->Deactivate();
  delete [] facteurs;
  delete [] actions;
  delete regle;


  // Java_fis_jnifis_NewRegularOutput
  cout <<"\nJava_fis_jnifis_NewRegularOutput";
  const char *defuz ="impli";
  const char *disj ="igg";
  int nb_sef=4;
  int  min=1;
  int max=2;
  double default_value=-10.;
  classif=false;
  OUT_FUZZY *new_output = NULL;
  sorted=NULL;
  new_output = new OUT_FUZZY( nb_sef, min, max, (char *)defuz,( char *)disj, classif, default_value ); 
  // implicative output-QSP regular grid
  if(!strcmp(defuz, OUT_FUZZY::ImpFuzzyDefuz()))
    new_output->Sfp2Qsp(sorted);
  delete  new_output;

  //Java_fis_jnifis_ReplaceMFOutput
  cout <<"\nJava_fis_jnifis_ReplaceMFOutput";
  FISOUT * sortie1 =fis->Out[0];
  MF *new_sef =fis->In[0]->GetMF(0)->Clone();
  int mf_number=0;
  sortie1->ReplaceMF( mf_number, new_sef );
   
  //Java_fis_jnifis_RemoveRule
  cout <<"\nJava_fis_jnifis_RemoveRule";
  int rule_number=0;
  fis->RemoveRule( rule_number ); 

  //Java_fis_jnifis_AddRule
  regle = new RULE(*(fis->Rule[0]),fis->In,fis->Out);
  sif->AddRule(regle);
  delete regle;

  //Java_fis_jnifis_NewFISFPA
  cout <<"\nJava_fis_jnifis_NewFISFPA";
  char *tmp = "temp";
  FISFPA *fisfpa = NULL;
  int strategy=1;
  int min_card=3;
  double min_deg=0.2;

  delete fis;
  fis=new FIS(argv[1]);
  f = fopen( tmp, "wt" );
  fis->PrintCfg(f);
  fclose(f);
  // genere le FIS FPA
  char *dataf = argv[2];
  fisfpa = new FISFPA(tmp, dataf, strategy, min_card, min_deg );
  for( int i=0 ; i<fisfpa->GetNbOut() ; i++ )
    fisfpa->FpaRules(i);
  if (! fisfpa->ComputeNbActRule())
    {
      sprintf( ErrorMsg, "~NoRuleInitializedUsingThisConfiguration~\n");
      throw std::runtime_error( ErrorMsg );
    }
  // sauvegarde du fis genere dans un fichier temporaire
  f = fopen( tmp, "wt" );
  fisfpa->PrintCfg(f);
  fclose(f);
  delete fisfpa;
  // ouverture du fis
  new_fis = new FIS(tmp);
  char *name = new char [strlen(new_fis->Name)+5];
  strcpy( name, new_fis->Name );
  strcat( name, ".fpa" );
  new_fis->SetName(name);
  delete 	new_fis;
  delete [] name;


  //Java_fis_jnifis_NewGENFIS
  cout <<"\nJava_fis_jnifis_NewGENFIS";
  bool sort=false;
  double thres=0.1;
  f = fopen( tmp, "wt" );
  fis->PrintCfg(f);
  fclose(f);
  dataf = argv[2];
  FIS *genfis = new GENFIS(tmp, dataf, sort, thres);
  // sauvegarde du fis genere dans un fichier temporaire
  f = fopen( tmp, "wt" );
  genfis->PrintCfg(f);
  fclose(f);
  delete genfis;
  // ouverture et renommage du fis
  genfis = new FIS(tmp);
  name = new char [strlen(genfis->Name)+5];
  strcpy( name, genfis->Name );
  strcat( name, ".gen" );
  genfis->SetName(name);
  delete [] name;
  delete genfis;

  
  //Java_fis_jnifis_NewTreeFIS
  cout <<"\nJava_fis_jnifis_NewTreeFIS";
  char *tree_file,*valid_file,* pruned_file;
  char * charResult=NULL;
  int maxdepth=2;
  bool FlagScarseDisplay=0;
  double min_ed_gain=0.1;
  double min_significant=0.1;
  double ambiguity_thres=1e-2;
  int outputNumber=0;
  bool prune=true;
  bool split=true;
  double relPerfLoss=0.1;
  bool grel=false;
  display=false;
  double covThresh=0.9;
  name = NULL;
  FISTREE *tree_fis = NULL;
  char *tmp_pruned = NULL;
  tmp = "fis";
  int res,nbrow, nbleaves=0,nbRemovedNodes=0,maxMF;
  int idisplay=0;
  int nbactrules, nbtotrules;
  int * misClass=NULL; // holds classif results
  double ** Examples = NULL;   // Ptr on data
  double * Lab=NULL;// labels for classif results
  double muperf,pf,coverage,maxError;
  FISOUT * crispout=NULL;
  double * outputClasses=NULL;
  InfoRB Irb;
  data_file =argv[2];
  delete fis;
  fis=new FIS(argv[1]);
  tree_file = "toto.tree";
  valid_file=argv[2];
  f = fopen( tmp, "wt" );
  fis->PrintCfg(f);
  fclose(f);
  // create a new fistree object
  tree_fis = new FISTREE(tmp, data_file, min_significant, ambiguity_thres,
			 outputNumber, outputClasses, crispout, covThresh); //outputNumber is used here - warning - outputnumber shifted by minus 1

  maxMF=tree_fis->CalcMaxMf();
  if (maxMF >99) throw std::runtime_error("~error~too~many~MFs~in~input~partitions\n~");
  // build tree with maximum depth

  nbleaves=tree_fis->BuildFullTree(tmp, tree_file, maxdepth, min_ed_gain, grel,
				   crispout,outputClasses,idisplay);


  //allocation of arrays for perf
  Examples=tree_fis->GetExamples();
  nbrow=tree_fis->GetNbex();
  //first allocates Classes array in the classification case
  //call only once if Examples does not change
  tree_fis->ClassifCheck(Examples,nbrow, outputNumber);
  //then allocates misclass array and updates lab pointer for classification results
  //note: classcheck could do it all in one pass, but is also calls checkconsistency
  //which is useless here
  //call only once if Examples does not change
  tree_fis->ResClassifAlloc(misClass, Lab, outputNumber);

  // compute performance of generated fis
  pf=tree_fis->Perf(outputNumber,  Examples, nbrow,
		    coverage,
		    maxError,
		    min_significant,
		    misClass,
		    Lab,true,NULL,0);
  // store RB characteristics in result.fistree

  charResult = new char [30];
  sprintf(charResult, "%s", "result.fistree");
  FILE * fres = fopen(charResult, "wt");


  //fprintf(fres, "fisname & Perf & Coverage & Max Error & MuMin & ");
  tree_fis->WriteHeaderPerfRB(outputNumber, fres);
  tree_fis->AnalyzeTreeWriteH(fres);
  fprintf(fres, "\n");
  tree_fis->PerfRB(pf,coverage,maxError,outputNumber,fres);
  // warning: next calls to Perf will have to first reassign Lab ptr to Classes array
  // because PerRB function reassigns Classes array (in defuz object) but does not reassign Lab ptr

  // print specific tree characteristics in result.fistree
  tree_fis->AnalyzeTree(fres,maxdepth,idisplay);
  fprintf(fres, "\n");
  // pruning

  if( prune )
    {
      pruned_file = new char[strlen(tree_file)+10];
      sprintf( pruned_file, "%s.pruned", tree_file );
      tmp_pruned ="prune.tree";
      muperf=min_significant;

      //tmp_pruned: FILENAME for fis equivalent to pruned tree
      //pruned_file: FILENAME for summary of pruned tree
      // Lab ptr reassigned in PrunetreePerf
      res = tree_fis->PruneTreePerf(tmp_pruned, pruned_file,valid_file,
				    misClass,Lab,muperf, relPerfLoss,
				    nbRemovedNodes, crispout, split,idisplay); //split is used here
      if( res <=0 )
	throw std::runtime_error("~ErrorInPruning~");

      Examples=tree_fis->GetExamples();
      nbrow=tree_fis->GetNbex();
      pf=tree_fis->Perf(outputNumber,  Examples, nbrow,
			coverage,
			maxError,
			muperf,
			misClass,
			Lab);

      // store RB characteristics in result.fistree file
      // temporary reset Number of rules=number of active rules
      // keep total number of rules in nbtotrules for correct destruction
      nbactrules=tree_fis->ComputeNbActRule();
      nbtotrules= tree_fis->GetNbRule();
      tree_fis->SetNbRule(nbactrules);
      // compute performance on validation file for result.fistree
      pf = tree_fis->Performance(outputNumber, valid_file,coverage , maxError,muperf , "perf.fistree",display );
      // store specific tree characteristics in result.fistree
      tree_fis->PerfRB(pf,coverage,maxError,outputNumber,fres);
      tree_fis->ResetAnalyze();
      tree_fis->AnalyzeTree(fres,maxdepth,idisplay);
      fprintf(fres, "\n");
      tree_fis->SetNbRule(nbtotrules);
    }// end of tree pruning
  //delete tree
  if(crispout!=NULL)
    tree_fis->SetNbOut(tree_fis->GetNbOut()+1);

  if (outputClasses != NULL) delete [] outputClasses;
  if (misClass != NULL) delete [] misClass;
  // Lab and crispout are only ptrs - do not delete them
  if (tree_fis != NULL) delete tree_fis;
  fclose(fres);
  delete [] charResult;
  delete [] pruned_file;
  cout <<"\n";
  

  // clean up
  if (data != NULL){
    for(int i = 0; i < nbex; i ++) delete [] data[i];
    delete [] data;
  }

  delete fis;
}
