//***********************************************************************
//
//
//
//
// Author(s) : Serge GUILLAUME, Brigitte CHARNOMORDIC 
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//**********************************************************************
/***************************************************************************
                          avect.h  -  description
                          define avect class
                             -------------------
    begin                : Wed Jun 5 2002
    email                : olivier@helios.inra.ensam.fr

    Class avect is used to applicate algorithms on doubles structure
***************************************************************************/
#include "avect.h"
// needed for gaussian function
avect::avect(int Vsize){
         vectValue = new double[Vsize];
         nbElem=Vsize;
         }
double avect::getValue(int i) const {
         return vectValue[i];
         }
void avect::setValue(int i, double d ){
         vectValue[i]=d;
         }
int  avect::getNbElem() const {
         return nbElem;
         }
avect::avect(int Vsize,double *DoubleArray){
         vectValue = new double[Vsize];
         nbElem=Vsize;
         for( int i=0 ; i<nbElem ; i++ ) {
           setValue(i,DoubleArray[i]);
           }
         }
void  avect::dupVector( avect *myvect , vkey * Key ){
         int ivect=0,ikey=0;
         while ( ivect < nbElem ) {
           while (  Key->getValue( ikey ) != 1 ) ikey++;
           setValue( ivect , myvect->getValue(ikey) );
           ikey++;ivect++;
           }
         return ;
         }
void  avect::print(void) const{
         printf(" ( " );
         for( int i=0 ; i<nbElem ; i++ )
         printf(" %f ", getValue(i));
         printf(" ) " );
         return;
         }
void  avect::print(int longueur) const{
         printf(" ( " );
         for( int i=0 ; i<longueur ; i++ )
         printf(" %f ", getValue(i));
         printf(" ) " );
         return;
         }


void  avect::init0( void ){
         for( int i=0 ; i<nbElem ; i++ )
                      vectValue[i] =  0;
         return ;
         }
void	avect::addVector( avect *v ){
         for( int i=0 ; i<nbElem ; i++ )
             vectValue[i] +=  v->getValue(i);
         return ;
         }
void	avect::dupVector( avect *v ){
         for( int i=0 ; i<nbElem ; i++ )
           vectValue[i] =  v->getValue(i);
           return ;
         }
void  avect::moinsuVector( void ){
         for( int i=0 ; i<nbElem ; i++ )
            vectValue[i] =  - vectValue[i];
         return ;
         }
void	avect::tlambVector( double k ){
         for( int i=0 ; i<nbElem ; i++ )
            vectValue[i] *= k;
         return ;
         }
// initGauss
// Generate a gaussian vector of noise alpha and average avg
void avect::initGauss( double alpha , avect * avg ){
        for( int i=0 ; i< nbElem ; i++ )
           setValue(i,GaussDice(alpha)+avg->getValue(i));
        return;
        }
