//***********************************************************************
//
//
//
//
// Author(s) : Serge GUILLAUME, Brigitte CHARNOMORDIC 
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//**********************************************************************
/*!
 * \file  fctalgo.h
 * \brief This file is used to declare the algo that has been implemented.
 *
 * when the program launch an algorythm, it switches the name ( an defined integer ) to know what function to call. To implement un other algorythm U must define it with the following signature, define an integer whith its name, include it in the switch case of algo::launch and include its definition in this header file...\n
 int anAlgo( void     * pYourObject ,
     vkey     * Key, 
     double   * ArrayOfDouble ,\n
     int        SizeArray,
     double   * evalresult,\n
   double  (* pointerEvaluationFunctiun )(\n
                              void   *  ,\n
                              vkey   *  ,\n
                              double *  ,\n
                              int       ,\n
                              conteneur * )\n
              )\n
 returns 0 if there where MaxIte iterations whithout solution\n
         the number of iterations if the floor is reached\n
        -1 the key set no bits\n
        -2 initial step evaluation is lesser than floor\n
        -3 there were no gain of performance\n
*/
class algoPar;
class conteneur;
//! Solis and Wett algorythm
int SolisWetts( void *, vkey * , double * , int , algoPar * , double *,
                 double  (* pfEval)( void   *  ,
                                     vkey   *  ,
                                     double *  ,
                                     int       ,
                                     conteneur * ),
                 conteneur *
              );
//! Hill Climbing algorythm
int FwdIfBetter( void *, vkey * , double * , int , algoPar * , double *,
                 double  (* pfEval)( void   *  ,
                                     vkey   *  ,
                                     double *  ,
                                     int       ,
                                     conteneur * ),
                 conteneur *
              );
//! Permutation algorythm use for limited vocabulary head rule optimasation.
int Permutation( void *, vkey * , double * , int , algoPar * , double *,
                 double  (* pfEval)( void   *  ,
                                     vkey   *  ,
                                     double *  ,
                                     int       ,
                                     conteneur * ),
                 conteneur *
              );
