//***********************************************************************
//
//
//
//
// Author(s) : Serge GUILLAUME, Brigitte CHARNOMORDIC 
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//**********************************************************************
/*!
 * \file sampleP.cpp
 * \brief sample of use of algo class whith a class point ( C++ ).

  Optimisation of a Point, using solis wetts algorythm.
  The evaluation function is the distance to 0 point.

 */
#include <iostream.h>
#include <stdlib.h>
#include "algo.h"
#include "point.h"
// First to use an algorythm you need to write three functions :
// 1  code your object into an double array using a boolean key
// 2  code an double array into an object using a boolean key
// 3  the evaluation function of your object

// 1 ) This function update an Array whith the Object and the bollean key
// for easier use of boolean key stored as an integer we will define
#define BOOL(x) (!(!(x)))
#define BitTst(arg,posn) BOOL((arg) & (1L << (posn)))
#define BitSet(arg,posn) ((arg) | (1L << (posn)))
#define BitClr(arg,posn) ((arg) & ~(1L << (posn)))
void ObjectToDouble ( void * Item , int  Key , double *Array )
         {
         Point *Ptmp=( Point * )Item;
         if ( ( BitTst( Key , 0 ) == 1 ) && ( BitTst( Key , 1 ) == 1 ) )
             {  Array[0]=Ptmp->x;
                Array[1]=Ptmp->y;
             };
        if ( ( BitTst( Key , 0 ) == 0 ) && ( BitTst( Key , 1 ) == 1 ) )
                                                      Array[0]=Ptmp->y;
         if ( ( BitTst( Key , 0 ) == 1 ) && ( BitTst( Key , 1 ) == 0 ) )
                                                      Array[0]=Ptmp->x;
#ifdef DEBUG3
             printf ( "\nfctObjectToDouble\n");
             Ptmp->Print();
             printf ( "Array %f %f \n",  Array[0], Array[1] );
             printf ( "Decimal Key %i \n",  Key  );
             printf ( "Binary Key %i %i \n",  BitTst(Key,0) , BitTst(Key,1) );
#endif
         return ;
         };
// 2 ) This function update an Array whith the Object and the bollean key
void DoubleToObject ( double * Array , int size , int Key ,void * P )
         {
         Point *Ptmp=( Point * )P;
         if ( ( BitTst( Key , 0 ) == 1 ) && ( BitTst( Key , 1 ) == 1 ) )
              {  Ptmp->x=Array[0];
                 Ptmp->y=Array[1];
               };
         if ( ( BitTst( Key , 0 ) == 0 ) && ( BitTst( Key , 1 ) == 1 ) )
                                                Ptmp->y=Array[0];
         if ( ( BitTst( Key , 0 ) == 1 ) && ( BitTst( Key , 1 ) == 0 ) )
                                                Ptmp->x=Array[0];
#ifdef DEBUG3
             printf ( "\nfctDoubleToObject");
             Ptmp->Print();
             printf ( "Array %f %f \n",  Array[0], Array[1] );
             printf ( "DecK %i \n",  Key  );
             printf ( "Binary Key %i %i \n",  BitTst(Key,0) , BitTst(Key,1) );
#endif
          return ;
        };

// 3 ) The evaluation function
// Second The evaluation function
// You can choose the name you want an pointer to tour function
// will be passed at the algorythm
// the function returns a double and have following params
double SamplePointEval(
// a pointer to an Object U try to optimize
                    void *  Item  ,
// which part of object U optimize
                    int  * myKeyAdress ,
// array of double ( values )
                    double *Array ,
// Array size
                    int sizeArray ,
// A set of void * pointers to pass to feval
                    conteneur *fEvalArgs )
       {
       int myKey=*myKeyAdress;
       double result=-1;
       char *passedChar;
// 3 operations :
//   cast void * to your type
//   rebuild object whith the key
//   get an evaluation of your object
        Point *P=(Point *) Item;
        DoubleToObject ( Array , sizeArray , myKey , P );
// reach an fEvalArgs
     passedChar=(char *)fEvalArgs->get(1);
#ifdef DEBUG
     printf("\nParametre du main %s\n",passedChar);
#endif
//   get evaluation of P2
        result=P->Norme();
        return result;
       };

int main(int argc, char *argv[])
{
  Point  *  P   = new Point ( 2 , 3 );
  double *  Tab = new double[2];
  double    gain;
  int       trouve,indice ;
// create a filename to pass to feval
  char fEvalFileName[20];
  strcpy(fEvalFileName,"TestPoint.dat\0");
  algo        *  A  = new algo( SOLISWETTS , 2 , 1 );
  // change algo params
  A->P->maxIte=40;
  A->P->floor=1;
// change feval params
  indice=A->fEvalArgs->add(fEvalFileName);
// pour toutes les cles
for ( int cptK = 1 ; cptK < 4  ; cptK++ )
       {
// set key to the algo using decimal form
        A-> setKey(cptK);
// as algo works on the item U pass this restore initial value of item
// after each step
        P->x=2; P->y=3;
// cast your object to an double
      ObjectToDouble ( P , cptK , Tab );
       trouve=A->launch( P, Tab , &gain, SamplePointEval );
#ifndef SPEEDY
    if ( trouve != 0 )
      { printf(" resultat trouve au bout de  %d iteration\n",trouve); }
      else
      { printf(" arret de l'algorithme apres %d iteration\n",A->P->maxIte); };
      P->Print();A->printKey();
     printf("\n Performance du vecteur transforme : %f \n-------------\n", gain );
#endif
    };

  delete A;
  delete [] Tab;
  delete P;

  exit(0);
}
