//***********************************************************************
//
//
//                              MAINHFPCFG.CPP
//
//
// Author(s) : Serge GUILLAUME, Brigitte CHARNOMORDIC 
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
// File : Main file for generating a configuration file for hfp, 
//        Fispro, part of package hfp (Hierarchical fuzzy partitioning)
//        requires library fispro
//
//**********************************************************************
#include "hfpfis.h"

int main(int argc, char ** argv)
//******************************
{
  if(argc < 3)
    {
      printf("\nThe program %s needs 2 arguments : ", argv[0]);
      printf("\n\t* the data file name;\n") ;
      printf("\n\t* the number of columns not to process (0 if hfp is applied to the output(s);") ;

      printf("\n\t\tOptions:");
      printf("\n\t\t the output file name (default: 'data file name'.hfp)");
      printf("\n\t\t the hierarchy type : 1 hfp, 2 kmeans, 3 regular (default=2)");
      printf("\n\t\t Warning : to use this option the previous one has to be specified");
      printf("\n\t* -wl for wordless.\n");
      printf("\n");
      return 1;
    }


  FISHFP *S=NULL;
  char * outcfg = NULL;
  int type = 0;
  bool wordless=false;
  

  try
    {
      
      if(argc > 3) outcfg = argv[3];
      if(argc > 4) type = atoi(argv[4]);
      if(argc > 5)
	if(! strncmp("-wl", argv[5], 3) ) wordless = true;

      S = new FISHFP (argv[1], atoi(argv[2]), outcfg, type);
      delete S;
      if(VarNameG != NULL) 
	{
	  for(int j = 0; j < NbVarG; j++)
	    if(VarNameG[j] != NULL)  delete [] VarNameG[j];
	  delete [] VarNameG;
	  VarNameG = NULL;
	}
      if (!wordless)
	printf("\nHfp configuration file written, please edit it.\n"); 
    }

  catch(std::exception &e)
    {
      printf("\n%s", e.what());
    }

  return 0;
}

