//**********************************************************************
//
//
//                              MAINHFPVERTEX.CPP
//
//
// Author(s) : Serge GUILLAUME, Brigitte CHARNOMORDIC 
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
// File : Main file for designing a family of partitions for each input 
//        Fispro, part of package hfp (Hierarchical fuzzy partitioning)
//        requires library fispro
//
//**********************************************************************
#include "hfpfis.h"

int main(int argc, char ** argv)
//******************************
{
  if(argc < 3)
    {
      printf("\nThe program %s needs 2 arguments : ", argv[0]);
      printf("\n\t* the data file name;\n") ;
      printf("\n\t* the hfp config file name;") ;

      printf("\n\t\tOptions:");
      printf("\n\t\t -oVertexFile:  the vertex output file name (default:  vertices.'Hierarchy, ex .hfp)");
      printf("\n");
      return 1;
    }


  FISHFP *S=NULL;
  char * fVertex = NULL;
  int i;

  try
    {
      if(argc > 3)
	for(i = 3; i < argc; i++)
	    if(! strncmp("-o", argv[i], 2) ) fVertex =  argv[i] + 2; 
      
      S = new FISHFP (argv[1], argv[2]);
      S->Hierarchy(fVertex);
		
      delete S;
      if(VarNameG != NULL) 
	{
	  for(int j = 0; j < NbVarG; j++)
	    if(VarNameG[j] != NULL)  delete [] VarNameG[j];
	  delete [] VarNameG;
	  VarNameG = NULL;
	}
    }
    
  catch(std::exception &e)
    {
      printf("\n%s", e.what());
    }

  return 0;
}

//***********           MAINHFPVERTEX.CPP   *************************
