//****************************************************************
//
//
//                              MAINSETHFPFIS.CPP
//
// Author(s) : Serge GUILLAUME, Brigitte CHARNOMORDIC 
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
// File : hierarchical fuzzy partitioning
// Environnment : requires library fispro
//****************************************************************


#include "sethfpfis.h"


int main(int argc, char ** argv)
{
  if(argc < 4)
    {
      printf("\nThe program %s needs 3 arguments : ", argv[0]);
      printf("\n\t* the input hfp configuration file;") ;
      printf("\n\t* a string containing the number of fuzzy sets for each input.") ;
      printf("\n\t* (use a space separator between them)");
      printf("\n\t* the output hfp configuration file. \n") ;
      return 1;
    }

  try
    {
      char *ch1 = NULL;
      char *ch2 = NULL;
      char *ch3 = NULL;
      ch1 = new char [strlen(argv[1]) + 10];
      ch2 = new char [strlen(argv[2]) + 10];
      ch3 = new char [strlen(argv[3]) + 10];
      sprintf(ch1, "%s", argv[1]);
      sprintf(ch2, "%s ", argv[2]);// add white space at the end for single input case
      sprintf(ch3, "%s", argv[3]);
      SetHfpFis(ch1,ch2,ch3);
      delete [] ch1;
      delete [] ch2;
      delete [] ch3;
    }

  catch(std::exception &e)
    {
      printf("\n%s\n", e.what());
    }

   return 0;
}

