//****************************************************************
//
//
//                             SETHFPFIS.H
//
// Author(s) : Serge GUILLAUME, Brigitte CHARNOMORDIC 
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
// File : hierarchical fuzzy partitioning
// Environnment : requires library fispro
//****************************************************************
#include "common.h"

//! Write a HFP configuration file from an input one by 
//! changing the number of MF for the input variables. 
//! 'In' is the input hfp configuration file name.  
//! 'Out' is the output hfp configuration file name. 
//! 'Cfg' is a string containing the number of fuzzy sets for each input 
//! variable (use a space separator between them). 
//! When the values are less numerous than the inputs,  
//! only the first inputs are modified. 
//! If the number of values is greater than the number of inputs,  
//! the last ones are ignored.
void SetHfpFis(char *In, char *Cfg, char *Out);


