//***********************************************************************
//
//
//                               LINKS.CPP
//
//
// Author(s) : Serge GUILLAUME, Brigitte CHARNOMORDIC 
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
// File : generate following working files 
//        rules.items, items.rules, rules.links and optionally rules.sorted
//        part of package links 
//        requires library fispro

//**********************************************************************

#include "linkfis.h"

int main(int argc, char ** argv)
  //****************************
{
  if(argc < 3)
    {
      printf("\nThe program %s needs 2  arguments : ", argv[0]);
      printf("\n\t* fis config file;");   
      printf("\n\t* data set file.") ;
      printf("\nOptions :") ;
      printf("\n\t* -sThres : minimum degree to consider the item fires the rule  (default 1e-6)");
      printf("\n\t* -t Sort the rules following their cumulated weight (default false)");
      printf("\n\t* -fResult file prefix (default "")");
      printf("\n");
      printf("\nThis program creates 4 files:  ");
      printf("\n items.rules, items.murules, rules.items, rules.links and, on request rules.sorted");
      printf("\n");

      return 1;
    }

  int i, OptTri = 0;
  double ThresMu = EPSILON;
  char * Prefix = NULL;

  if(argc > 3) 
    {
      for(i = 3; i < argc; i++)
	{	
	  if(! strcmp("-t", argv[i]) ) OptTri = 1;
	  else if(! strncmp("-s", argv[i], 2) )  ThresMu = strtod(argv[i] + 2, NULL);
	  else if(! strncmp("-f", argv[i], 2) )  Prefix = argv[i] + 2;
	}
    }
  try
    {
      FISLINK S(argv[1], argv[2], ThresMu, OptTri, Prefix);
    }

  catch(std::exception &e)
    {
      printf("\n%s", e.what());
    }
 
  return 0;
}

//**************************   End of LINKS.CPP   *************************************
