//***********************************************************************
//
//
//                              SPARENTNODE.H
//
//
// Author(s) : Vincent Therry
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Contact : vincent.therry@envilys.com
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
// File : SUPERSIF PARENT NODE class functions used by FISPRO, part of library fispro

//**********************************************************************
#ifndef SPARENTNODE_H_
#define SPARENTNODE_H_

//#include "fis.h"
#include "snode.h" 

class SPARENTNODE : public SNODE
{
	
	protected :	
		// Pointer on the vector containing subordinates SNodes
		vector <SNODE *> * m_pvclSNodes;
	
	public :	
		// Constructors
		SPARENTNODE();
		SPARENTNODE(const SPARENTNODE & s);
		SPARENTNODE(char * sFisFileName, double ** adDataArray, int nNbRows, vector <int> * pviSelectedColumns, vector <SNODE *> * pvclSNodes);	
		~SPARENTNODE();
		
		// Getters
		vector <SNODE *> * pvclGetSNodes();
		
		// Setters
		void SetSNodes(vector <SNODE *> * pvclSNodes);
		
		// Methods
		virtual void Infer();
		virtual void ToString();				
};

#endif /*SUPERIORNODE_H_*/
