//***********************************************************************
//
//
//                              SUPERFIS.H
//
//
// Author(s) : Vincent Therry
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Contact : vincent.therry@envilys.com
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
// File : SUPERFIS class functions used by FISPRO, part of library fispro

//**********************************************************************
#ifndef SUPERFIS_H_
#define SUPERFIS_H_

//#include "fis.h"
#include "snode.h"
#include "sleafnode.h"
#include "sparentnode.h"
#include <typeinfo>

class SUPERFIS
{
	protected :
		// Pointer on the array containing all input datas
		double ** m_adInputs;
		
		// Datas Array's informations
		int m_nNbCols;
		int m_nNbRows;
		
		// Pointer on the array containing SuperFis's SNodes
		vector <SNODE *> * m_pvclSNodes;
		
		// Tree's root
		SNODE * m_pclRoot;
	
	public :	
		// Constructor
		SUPERFIS();
		SUPERFIS(const SUPERFIS & s);
		SUPERFIS(char * sDataFilename, char *sConfigFileName);
		SUPERFIS(double ** adInputs, int nNb_Cols, int nNb_Rows, char *sConfigFileName);
		~SUPERFIS();
		
		// Getters
		double ** adGetInputs();
		int nGetNbCols();
		int nGetNbRows();
		vector <SNODE *> * pvclGetSNodes();
		SNODE * pclGetRoot();
		
		// Setters
		void SetInputs(double ** adInputs);
		void SetNbCols(int nNbCols);
		void SetNbRows(int nNbRows);
		void SetSNodes(vector <SNODE *> * pvclSNodes);
		void SetRoot(SNODE * pclRoot);
		
		// Methods
		void Infer();	
		void ToString();
		void Init(char * sConfigFileName);		
};

#endif /*SUPERFIS_H_*/
