#include <base/fuzzy_distance.hpp>

namespace fispro {

fuzzy_distance::fuzzy_distance(FISIN &fisin) : fisin(fisin) {}

bool fuzzy_distance::operator==(const fuzzy_distance &other) const {
	// FISIN::operator != should be const
	return !(const_cast<FISIN &>(fisin) != other.fisin);
}

double fuzzy_distance::operator()(double lhs, double rhs) const {
	// FISIN::Distance should be const
	return const_cast<FISIN &>(fisin).Distance(lhs, rhs);
}

void fuzzy_distance::normalize() {
	fisin.Normalize();
}

void fuzzy_distance::unnormalize() {
	fisin.UnNormalize();
}

} // namespace fispro
